/*
 * Book's Story — free and open-source Material You eBook reader.
 * Copyright (C) 2024-2026 Acclorite
 * SPDX-License-Identifier: GPL-3.0-only
 */

package org.dueattendant149.bookshelf.domain.use_case.book

import androidx.core.net.toUri
import org.dueattendant149.bookshelf.core.log.logE
import org.dueattendant149.bookshelf.core.log.logI
import org.dueattendant149.bookshelf.core.log.logW
import org.dueattendant149.bookshelf.domain.repository.BookRepository
import org.dueattendant149.bookshelf.domain.service.CoverImageHandler
import javax.inject.Inject

private const val TAG = "ResetCoverImage"

class ResetCoverImageUseCase @Inject constructor(
    private val bookRepository: BookRepository,
    private val coverImageHandler: CoverImageHandler
) {

    suspend operator fun invoke(bookId: Int): Boolean {
        logI(TAG, "Resetting cover image of [$bookId].")

        bookRepository.getBook(bookId).mapCatching { book ->
            // Getting default cover image
            val defaultCoverImage = bookRepository.getDefaultCover(book).getOrThrow()
                ?: throw NoSuchElementException("Could not find default cover image")

            // Deleting old cover
            book.coverImage?.let { coverImageHandler.deleteCover(it) }?.onFailure {
                logW(TAG, "Could not delete old cover image with error: ${it.message}")
            }

            // Resetting cover
            val newCoverImage = defaultCoverImage.let {
                coverImageHandler.saveCover(it).getOrThrow()
            }

            book.copy(coverImage = newCoverImage.toUri())
        }.mapCatching { newBook ->
            bookRepository.updateBook(newBook).getOrThrow()
        }.fold(
            onSuccess = {
                logI(TAG, "Successfully reset cover image of [$bookId].")
                return true
            },
            onFailure = {
                logE(TAG, "Could not reset cover image of [$bookId] with error: ${it.message}")
                return false
            }
        )
    }
}